%--------------------------------------------------------------------------
%               Systems and control theory
%               Prof: Luigi Biagiotti
%               Solution of exercises #4a
%--------------------------------------------------------------------------

clear all
close all
clc

%% 1st point.

a = 0.9;
b = 0.01;
c = 0.8;
d = 0.01;

x0=[70; 70]; % Initial condition for the nonlinear system
options = simset('MaxStep',0.001); % reduction of the step size to improve the simulation (default value 0.2)
sim('PreyPredator_mdl',100,options)
timenl = time;
plot(x1,x2)
grid on
hold on
plot(x0(1),x0(2),'*')
xlabel('x_1')
ylabel('x_2')

figure
plot(time,x1)
hold on
grid on
plot(time,x2,'r--')
legend('prey','predators')
xlabel('time')
ylabel('x_1, x_2')

%% 2nd point.

xe = [c/d;a/b];
[A,B,C,D]=linmod('PreyPredator_mdl',xe,[]);
eig(A)
D = zeros(2,2); % It is necessary to define a not-empty matrix D for the state-space block 

%% 3rd point.
x0sl = x0-xe; %Initial condition for the linearized system
sim('PreyPredatorSS_mdl',100,options)
figure
subplot(2,1,1)
plot(timenl,x1,'r--')
xlabel('time')
ylabel('x_1')
grid on
hold on
plot(time,xe(1)+x1ss)
subplot(2,1,2)
plot(timenl,x2,'r--')
grid on
hold on
plot(time,xe(2)+x2ss)
xlabel('time')
ylabel('x_2')


figure %Comparison between the trajectories of the linearized and nonlinear system
plot(x1,x2,'r--')
hold on
grid on
plot(xe(1)+x1ss,xe(2)+x2ss)
legend('nonlinear system','linearized system')
xlabel('x_1')
ylabel('x_2')